# coding=utf-8
# *** WARNING: this file was generated by Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
import pulumi_aws

__all__ = ['PublicBucketPolicyArgs', 'PublicBucketPolicy']

@pulumi.input_type
class PublicBucketPolicyArgs:
    def __init__(__self__, *,
                 bucket: pulumi.Input['pulumi_aws.s3.Bucket']):
        """
        The set of arguments for constructing a PublicBucketPolicy resource.
        :param pulumi.Input['pulumi_aws.s3.Bucket'] bucket: The bucket to apply the public policy to.
        """
        pulumi.set(__self__, "bucket", bucket)

    @property
    @pulumi.getter
    def bucket(self) -> pulumi.Input['pulumi_aws.s3.Bucket']:
        """
        The bucket to apply the public policy to.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: pulumi.Input['pulumi_aws.s3.Bucket']):
        pulumi.set(self, "bucket", value)


class PublicBucketPolicy(pulumi.ComponentResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bucket: Optional[pulumi.Input['pulumi_aws.s3.Bucket']] = None,
                 __props__=None):
        """
        Create a PublicBucketPolicy resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input['pulumi_aws.s3.Bucket'] bucket: The bucket to apply the public policy to.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PublicBucketPolicyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a PublicBucketPolicy resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param PublicBucketPolicyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PublicBucketPolicyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bucket: Optional[pulumi.Input['pulumi_aws.s3.Bucket']] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is not None:
            raise ValueError('ComponentResource classes do not support opts.id')
        else:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PublicBucketPolicyArgs.__new__(PublicBucketPolicyArgs)

            if bucket is None and not opts.urn:
                raise TypeError("Missing required property 'bucket'")
            __props__.__dict__["bucket"] = bucket
            __props__.__dict__["ownership_controls"] = None
            __props__.__dict__["public_access_block"] = None
        super(PublicBucketPolicy, __self__).__init__(
            'aws-static-website:index:PublicBucketPolicy',
            resource_name,
            __props__,
            opts,
            remote=True)

    @property
    @pulumi.getter(name="ownershipControls")
    def ownership_controls(self) -> pulumi.Output['pulumi_aws.s3.BucketOwnershipControls']:
        return pulumi.get(self, "ownership_controls")

    @property
    @pulumi.getter(name="publicAccessBlock")
    def public_access_block(self) -> pulumi.Output['pulumi_aws.s3.BucketPublicAccessBlock']:
        return pulumi.get(self, "public_access_block")

